const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class AccountsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const accounts = await db.accounts.create(
      {
        id: data.id || undefined,

        balance: data.balance || null,
        debt_limit: data.debt_limit || null,
        current_debt: data.current_debt || null,
        account_type: data.account_type || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await accounts.setPartner(data.partner || null, {
      transaction,
    });

    await accounts.setKooperatif(data.kooperatif || null, {
      transaction,
    });

    return accounts;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const accountsData = data.map((item, index) => ({
      id: item.id || undefined,

      balance: item.balance || null,
      debt_limit: item.debt_limit || null,
      current_debt: item.current_debt || null,
      account_type: item.account_type || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const accounts = await db.accounts.bulkCreate(accountsData, {
      transaction,
    });

    // For each item created, replace relation files

    return accounts;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const accounts = await db.accounts.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.balance !== undefined) updatePayload.balance = data.balance;

    if (data.debt_limit !== undefined)
      updatePayload.debt_limit = data.debt_limit;

    if (data.current_debt !== undefined)
      updatePayload.current_debt = data.current_debt;

    if (data.account_type !== undefined)
      updatePayload.account_type = data.account_type;

    updatePayload.updatedById = currentUser.id;

    await accounts.update(updatePayload, { transaction });

    if (data.partner !== undefined) {
      await accounts.setPartner(
        data.partner,

        { transaction },
      );
    }

    if (data.kooperatif !== undefined) {
      await accounts.setKooperatif(
        data.kooperatif,

        { transaction },
      );
    }

    return accounts;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const accounts = await db.accounts.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of accounts) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of accounts) {
        await record.destroy({ transaction });
      }
    });

    return accounts;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const accounts = await db.accounts.findByPk(id, options);

    await accounts.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await accounts.destroy({
      transaction,
    });

    return accounts;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const accounts = await db.accounts.findOne({ where }, { transaction });

    if (!accounts) {
      return accounts;
    }

    const output = accounts.get({ plain: true });

    output.transactions_account = await accounts.getTransactions_account({
      transaction,
    });

    output.partner = await accounts.getPartner({
      transaction,
    });

    output.kooperatif = await accounts.getKooperatif({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userKooperatif = (user && user.kooperatif?.id) || null;

    if (userKooperatif) {
      if (options?.currentUser?.kooperatifId) {
        where.kooperatifId = options.currentUser.kooperatifId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.partners,
        as: 'partner',

        where: filter.partner
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.partner
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.partner
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.kooperatif,
        as: 'kooperatif',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.balanceRange) {
        const [start, end] = filter.balanceRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            balance: {
              ...where.balance,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            balance: {
              ...where.balance,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.debt_limitRange) {
        const [start, end] = filter.debt_limitRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            debt_limit: {
              ...where.debt_limit,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            debt_limit: {
              ...where.debt_limit,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.current_debtRange) {
        const [start, end] = filter.current_debtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            current_debt: {
              ...where.current_debt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            current_debt: {
              ...where.current_debt,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.account_type) {
        where = {
          ...where,
          account_type: filter.account_type,
        };
      }

      if (filter.kooperatif) {
        const listItems = filter.kooperatif.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          kooperatifId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.kooperatifId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.accounts.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('accounts', 'account_type', query),
        ],
      };
    }

    const records = await db.accounts.findAll({
      attributes: ['id', 'account_type'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['account_type', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.account_type,
    }));
  }
};
